summaryrefslogtreecommitdiff
path: root/localedata/tst-locale.sh
diff options
context:
space:
mode:
authorCarlos O'Donell <carlos@systemhalted.org>2017-10-13 09:54:03 -0700
committerCarlos O'Donell <carlos@systemhalted.org>2017-10-13 22:30:18 -0700
commitf16491eb8ebbef402f3da6f4035ce70fe36dec97 (patch)
tree686168ada3db669666f891e44158e8a092cc2bd7 /localedata/tst-locale.sh
parent8dc8be75d2afb7ebaf55f7609b301e5c6b8692e5 (diff)
locale: Fix localedef exit code (Bug 22292)
The error and warning handling in localedef, locale, and iconv is a bit of a mess. We use ugly constructs like this: WITH_CUR_LOCALE (error (1, errno, gettext ("\ cannot read character map directory `%s'"), directory)); to issue errors, and read error_message_count directly from the error API to detect errors. The problem with that is that the code also uses error to print warnings, and informative messages. All of this leads to problems where just having warnings will produce an exit status as-if errors had been seen. To fix this situation I have adopted the following high-level changes: * All errors are counted distinctly. * All warnings are counted distinctly. * All informative messages are not counted. * Increasing verbosity cannot generate *more* errors, and it previously did for errors conditional on verbose, this is now fixed. * Increasing verbosity *can* generate *more* warnings. * Making the output quiet cannot generate *fewer* errors, and it previously did for errors conditional on be_quiet, this is now fixed. * Each of error, warning, and informative message has it's own function to call defined in record-status.h, and they are: record_error, record_warning, and record_verbose. * The record_error function always records an error, but conditional on be_quiet may not print it. * The record_warning function always records a warning, but conditional on be_quiet may not print it. * The record_verbose function only prints the verbose message if verbose is true and be_quiet is false. This has allowed the following fix: * Previously any warnings were being treated as errors because they incremented error_message_count, but now we properly return an exit status of 1 if there are warnings but output was generated. All of this allows localedef to correctly decide if errors, or warnings were present, and produce the correct exit code. The locale and iconv programs now also use record-status.h and we have removed the WITH_CUR_LOCALE hack, and instead have internal push_locale/pop_locale functions centralized in the record routines. Signed-off-by: Carlos O'Donell <carlos@redhat.com>
Diffstat (limited to 'localedata/tst-locale.sh')
-rwxr-xr-xlocaledata/tst-locale.sh19
1 files changed, 15 insertions, 4 deletions
diff --git a/localedata/tst-locale.sh b/localedata/tst-locale.sh
index c73c1087d3..2d7da3c4a1 100755
--- a/localedata/tst-locale.sh
+++ b/localedata/tst-locale.sh
@@ -34,18 +34,29 @@ test_locale ()
if test $rep; then
rep="--repertoire-map $rep"
fi
+ # We expect the test locales to fail with warnings, they are mostly
+ # incomplete and used for testing purposes, but that is OK.
+ ret=0
${localedef_before_env} \
${run_program_env} \
I18NPATH=. \
${localedef_after_env} --quiet -c -f $charmap -i $input \
- ${rep} ${common_objpfx}localedata/$out
-
- if [ $? -ne 0 ]; then
+ ${rep} ${common_objpfx}localedata/$out || ret=$?
+ # Any error greater than one means we ran into an implementation
+ # defined limit or saw an error that caused the output not to
+ # be written, or lastly saw a fatal error that terminated
+ # localedef.
+ if [ $ret -gt 1 ]; then
echo "Charmap: \"${charmap}\" Inputfile: \"${input}\"" \
"Outputdir: \"${out}\" failed"
exit 1
else
- echo "locale $out generated succesfully"
+ echo -n "locale $out generated succesfully"
+ if [ $ret -eq 1 ]; then
+ echo " (with warnings)"
+ else
+ echo " (without warnings)"
+ fi
fi
}